package org.wfc.omada.api.organization.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * BatchCopySiteTemplateOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:17:18.430+08:00[Asia/Shanghai]")

public class BatchCopySiteTemplateOpenApiVo   {
  @JsonProperty("name")
  private String name;

  @JsonProperty("targetOmadacs")
  @Valid
  private List<String> targetOmadacs = new ArrayList<>();

  public BatchCopySiteTemplateOpenApiVo name(String name) {
    this.name = name;
    return this;
  }

  /**
   * Name of the site should contain 1 to 64 characters.
   * @return name
  */
  @ApiModelProperty(required = true, value = "Name of the site should contain 1 to 64 characters.")
  @NotNull

@Pattern(regexp="^[^ \\+\\-\\@\\=]$|^[^ \\+\\-\\@\\=].{0,62}[^ ]$") 
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public BatchCopySiteTemplateOpenApiVo targetOmadacs(List<String> targetOmadacs) {
    this.targetOmadacs = targetOmadacs;
    return this;
  }

  public BatchCopySiteTemplateOpenApiVo addTargetOmadacsItem(String targetOmadacsItem) {
    this.targetOmadacs.add(targetOmadacsItem);
    return this;
  }

  /**
   * The target Customer ID needs to be obtained from the interface \"Obtain the customer ID with permission to modify site templates\".
   * @return targetOmadacs
  */
  @ApiModelProperty(required = true, value = "The target Customer ID needs to be obtained from the interface \"Obtain the customer ID with permission to modify site templates\".")
  @NotNull

@Size(min=0,max=10) 
  public List<String> getTargetOmadacs() {
    return targetOmadacs;
  }

  public void setTargetOmadacs(List<String> targetOmadacs) {
    this.targetOmadacs = targetOmadacs;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BatchCopySiteTemplateOpenApiVo batchCopySiteTemplateOpenApiVo = (BatchCopySiteTemplateOpenApiVo) o;
    return Objects.equals(this.name, batchCopySiteTemplateOpenApiVo.name) &&
        Objects.equals(this.targetOmadacs, batchCopySiteTemplateOpenApiVo.targetOmadacs);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, targetOmadacs);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BatchCopySiteTemplateOpenApiVo {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    targetOmadacs: ").append(toIndentedString(targetOmadacs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

